<?php

/*
Plugin Name: Google+ for Wordpress
Version: Beta 0.2
Plugin URI: http://gfxcomplex.com/google-plus-for-wordpress/
Description: Displays your public Google+ posts for all to read. Based on <a href="http://cavemonkey50.com/code/pownce/">Pownce for Wordpress</a> by <a href="http://cavemonkey50.com/">Cavemonkey50</a>.
Author: Joshua Chernoff
Author URI: http://gfxcomplex.com
*/

/*  Copyright 2011  Josh Chenroff GFX Complex (jchernoff[at]gfxcomplex.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/



define('MAGPIE_CACHE_ON', 		1); //2.7 Cache Bug
define('MAGPIE_CACHE_AGE', 		180);
define('MAGPIE_INPUT_ENCODING', 'UTF-8');
define('MAGPIE_OUTPUT_ENCODING','UTF-8');
define('DOMAIN_API', 			'http://plusfeed.appspot.com/');

add_action('init', 'add_plus1_button_header');  

$googleplus_options['widget_fields']['title'] 					= array('label'=>'Title:', 				'type'=>'text', 	'default'=>'');
$googleplus_options['widget_fields']['userid'] 					= array('label'=>'Google+ User ID:', 	'type'=>'text', 	'default'=>'');
$googleplus_options['widget_fields']['num'] 					= array('label'=>'Number of links:', 	'type'=>'text', 	'default'=>'1');
$googleplus_options['widget_fields']['update'] 					= array('label'=>'Show timestamps:', 	'type'=>'checkbox', 'default'=>true);
$googleplus_options['widget_fields']['linked'] 					= array('label'=>'Linked:', 			'type'=>'text', 	'default'=>'https://plus.google.com/');
//$googleplus_options['widget_fields']['googleplus_hyperlinks'] = array('label'=>'Discover googleplus_hyperlinks:','type'=>'checkbox', 'default'=>true);
//$googleplus_options['widget_fields']['googleplus_users']		= array('label'=>'Discover @replies:',  'type'=>'checkbox', 'default'=>true);
$googleplus_options['widget_fields']['encode_utf8'] 			= array('label'=>'UTF8 Encode:', 		'type'=>'checkbox', 'default'=>false);

$googleplus_options['prefix'] = 'googleplus';

function add_plus1_button_header(){
	wp_register_script( 'plusone', 'https://apis.google.com/js/plusone.js' );
	wp_enqueue_script( 'plusone' );
}

// Display googleplus messages
function googleplus_messages($userid = '', $num = 1, $list = false, $update = true, $linked  = '[...]', $googleplus_hyperlinks = true, $googleplus_users = true, $encode_utf8 = false) {
	
	global $googleplus_options;
	include_once(ABSPATH . WPINC . '/rss.php');
	
	$messages = fetch_rss(DOMAIN_API.$userid);

	if ($list) echo '<ul class="googleplus">';
	
	if ($userid == '') {
		if ($list) echo '<li>';
		echo 'RSS not configured';
		if ($list) echo '</li>';
	} else {		
			if ( empty($messages->items) ) {
				if ($list) echo '<li>';
				echo 'No public googleplus messages.';
				if ($list) echo '</li>';
			} else {
       		$i = 0;
			foreach ( $messages->items as $message ) {
			$msg = $message['title'];
			if($encode_utf8) $msg = utf8_encode($msg);			
			$link = $message['link'];		
					
			if ($list) echo '<li class="googleplus-item">'; elseif ($num != 1) echo '<p class="googleplus-message">';
          	//if ($googleplus_hyperlinks) { $msg = googleplus_hyperlinks($msg); }
          	//if ($googleplus_users)  { $msg = googleplus_users($msg); }
          					
			if ($linked != '' || $linked != false) {
				if($linked == 'all')  { 
				  $msg = '<a href="'.$link.'" class="googleplus-link">'.$msg.'</a>';
				} else {
				   $msg = '<a href="'.$link.'" class="googleplus-link">'.$msg.'</a>'; // $msg = $msg . ' <a href="'.$link.'" class="googleplus-link">'.$linked.'</a>';	  
				}
          	} 
		 
          echo $msg;
		   ?>
		  <br/><g:plusone size="small" href=<?php echo $link; ?>></g:plusone>
          <?php
          
        /*if($update) {				
          $time = strtotime($message['pubdate']);          
          if ( ( abs( time() - $time) ) < 86400 )
            $h_time = sprintf( __('%s ago'), human_time_diff( $time ) );
          else
            $h_time = date(__('Y/m/d'), $time);
			echo sprintf( __('%s', 'googleplus-for-wordpress'),' <span class="googleplus-timestamp"><abbr title="' . date(__('Y/m/d H:i:s'), $time) . '">' . $h_time . '</abbr></span>' );
		}  */              
				if ($list) echo '</li>'; elseif ($num != 1) echo '</p>';				
					$i++;
					if ( $i >= $num ) break;
				}
			}
		}
		if ($list) echo '</ul>';
		//echo print_r($messages);
	}

// Link discover stuff
function googleplus_hyperlinks($text) {
    // Props to Allen Shaw & webmancers.com
    // match protocol://address/path/file.extension?some=variable&another=asf%
    //$text = preg_replace("/\b([a-zA-Z]+:\/\/[a-z][a-z0-9\_\.\-]*[a-z]{2,6}[a-zA-Z0-9\/\*\-\?\&\%]*)\b/i","<a href=\"$1\" class=\"googleplus-link\">$1</a>", $text);
    $text = preg_replace('/\b([a-zA-Z]+:\/\/[\w_.\-]+\.[a-zA-Z]{2,6}[\/\w\-~.?=&%#+$*!]*)\b/i',"<a href=\"$1\" class=\"googleplus-link\">$1</a>", $text);
    // match www.something.domain/path/file.extension?some=variable&another=asf%
    //$text = preg_replace("/\b(www\.[a-z][a-z0-9\_\.\-]*[a-z]{2,6}[a-zA-Z0-9\/\*\-\?\&\%]*)\b/i","<a href=\"http://$1\" class=\"googleplus-link\">$1</a>", $text);
    $text = preg_replace('/\b(?<!:\/\/)(www\.[\w_.\-]+\.[a-zA-Z]{2,6}[\/\w\-~.?=&%#+$*!]*)\b/i',"<a href=\"http://$1\" class=\"googleplus-link\">$1</a>", $text);    
    
    // match name@address
    $text = preg_replace("/\b([a-zA-Z][a-zA-Z0-9\_\.\-]*[a-zA-Z]*\@[a-zA-Z][a-zA-Z0-9\_\.\-]*[a-zA-Z]{2,6})\b/i","<a href=\"mailto://$1\" class=\"googleplus-link\">$1</a>", $text);
        //mach #trendingtopics. Props to Michael Voigt
    $text = preg_replace('/([\.|\,|\:|\|\|\>|\{|\(]?)#{1}(\w*)([\.|\,|\:|\!|\?|\>|\}|\)]?)\s/i', "$1<a href=\"http://googleplus.com/#search?q=$2\" class=\"googleplus-link\">#$2</a>$3 ", $text);
    return $text;
}

function googleplus_users($text) {
       $text = preg_replace('/([\.|\,|\:|\|\|\>|\{|\(]?)@{1}(\w*)([\.|\,|\:|\!|\?|\>|\}|\)]?)\s/i', "$1<a href=\"http://googleplus.com/$2\" class=\"googleplus-user\">@$2</a>$3 ", $text);
       return $text;
} 

// googleplus widget stuff
function widget_googleplus_init() {

	if ( !function_exists('register_sidebar_widget') )
		return;
	
	$check_options = get_option('widget_googleplus');
  if ($check_options['number']=='') {
    $check_options['number'] = 1;
    update_option('widget_googleplus', $check_options);
  }
  
	function widget_googleplus($args, $number = 1) {

		global $googleplus_options;
		
		// $args is an array of strings that help widgets to conform to
		// the active theme: before_widget, before_title, after_widget,
		// and after_title are the array keys. Default tags: li and h2.
		extract($args);

		// Each widget can store its own options. We keep strings here.
		include_once(ABSPATH . WPINC . '/rss.php');
		$options = get_option('widget_googleplus');
		
		// fill options with default values if value is not set
		$item = $options[$number];
		foreach($googleplus_options['widget_fields'] as $key => $field) {
			if (! isset($item[$key])) {
				$item[$key] = $field['default'];
			}
		}
		
		$messages = fetch_rss(DOMAIN_API.$item['username']);


		// These lines generate our output.
    echo $before_widget . $before_title . '<a href="http://plus.google.com/' . $item['userid'] . '" class="googleplus_title_link">'. $item['title'] . '</a>' . $after_title;
		googleplus_messages($item['userid'], $item['num'], true, $item['update'], $item['linked'], $item['hyperlinks'], $item['googleplus_users'], $item['encode_utf8']);
		echo $after_widget;
				
	}

	// This is the function that outputs the form to let the users edit
	// the widget's title. It's an optional feature that users cry for.
	function widget_googleplus_control($number) {
	
		global $googleplus_options;

		// Get our options and see if we're handling a form submission.
		$options = get_option('widget_googleplus');
		if ( isset($_POST['googleplus-submit']) ) {

			foreach($googleplus_options['widget_fields'] as $key => $field) {
				$options[$number][$key] = $field['default'];
				$field_name = sprintf('%s_%s_%s', $googleplus_options['prefix'], $key, $number);

				if ($field['type'] == 'text') {
					$options[$number][$key] = strip_tags(stripslashes($_POST[$field_name]));
				} elseif ($field['type'] == 'checkbox') {
					$options[$number][$key] = isset($_POST[$field_name]);
				}
			}

			update_option('widget_googleplus', $options);
		}

		foreach($googleplus_options['widget_fields'] as $key => $field) {
			
			$field_name = sprintf('%s_%s_%s', $googleplus_options['prefix'], $key, $number);
			$field_checked = '';
			if ($field['type'] == 'text') {
				$field_value = htmlspecialchars($options[$number][$key], ENT_QUOTES);
			} elseif ($field['type'] == 'checkbox') {
				$field_value = 1;
				if (! empty($options[$number][$key])) {
					$field_checked = 'checked="checked"';
				}
			}
			
			printf('<p style="text-align:right;" class="googleplus_field"><label for="%s">%s <input id="%s" name="%s" type="%s" value="%s" class="%s" %s /></label></p>',
				$field_name, __($field['label']), $field_name, $field_name, $field['type'], $field_value, $field['type'], $field_checked);
		}

		echo '<input type="hidden" id="googleplus-submit" name="googleplus-submit" value="1" />';
	}
	
	function widget_googleplus_setup() {
		$options = $newoptions = get_option('widget_googleplus');
		
		if ( isset($_POST['googleplus-number-submit']) ) {
			$number = (int) $_POST['googleplus-number'];
			$newoptions['number'] = $number;
		}
		
		if ( $options != $newoptions ) {
			update_option('widget_googleplus', $newoptions);
			widget_googleplus_register();
		}
	}
	
	
	function widget_googleplus_page() {
		$options = $newoptions = get_option('widget_googleplus');
	?>
		<div class="wrap">
			<form method="POST">
				<h2><?php _e('Google+ Widgets'); ?></h2>
				<p style="line-height: 30px;"><?php _e('How many Google+ widgets would you like?'); ?>
				<select id="googleplus-number" name="googleplus-number" value="<?php echo $options['number']; ?>">
	<?php for ( $i = 1; $i < 10; ++$i ) echo "<option value='$i' ".($options['number']==$i ? "selected='selected'" : '').">$i</option>"; ?>
				</select>
				<span class="submit"><input type="submit" name="googleplus-number-submit" id="googleplus-number-submit" value="<?php echo attribute_escape(__('Save')); ?>" /></span></p>
			</form>
		</div>
	<?php
	}
	
	
	function widget_googleplus_register() {
		
		$options = get_option('widget_googleplus');
		$dims = array('width' => 300, 'height' => 300);
		$class = array('classname' => 'widget_googleplus');

		for ($i = 1; $i <= 9; $i++) {
			$name = sprintf(__('Google+ ID #%d'), $i);
			$id = "googleplus-$i"; // Never never never translate an id
			wp_register_sidebar_widget($id, $name, $i <= $options['number'] ? 'widget_googleplus' : /* unregister */ '', $class, $i);
			wp_register_widget_control($id, $name, $i <= $options['number'] ? 'widget_googleplus_control' : /* unregister */ '', $dims, $i);
		}
		
		add_action('sidebar_admin_setup', 'widget_googleplus_setup');
		add_action('sidebar_admin_page', 'widget_googleplus_page');
	}

	widget_googleplus_register();
}

// Run our code later in case this loads prior to any required plugins.
add_action('widgets_init', 'widget_googleplus_init');

?>